﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;//pt fisiere

namespace Roboti
{
    public partial class Form1 : Form
    {
        int n, m,i1,j1,i2,j2;
        int[,] A;//harta
        Button[,] B;//matrice de butoane

        struct pozitie
        {
            public int i, j;
        }
        Queue<pozitie> Q;//pozitiile prin care trece
        int[] di={0,1,0,-1};
        int[] dj={1,0,-1,0};

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            richTextBox1.LoadFile("c++.rtf");
            richTextBox2.LoadFile("Lee.rtf");
        }

        private void button1_Click(object sender, EventArgs e)
        {
            openFileDialog1.FileName = "";
            openFileDialog1.Filter = "Fisiere text|*.txt";
            if(openFileDialog1.ShowDialog()==DialogResult.OK)
            {
                string fisier = openFileDialog1.FileName;
                StreamReader fin = new StreamReader(fisier);
                string l;
                //citesc n,m
                l = fin.ReadLine();
                string[] s = l.Split();
                n = int.Parse(s[0]);
                m = int.Parse(s[1]);
                //creez matricea
                A = new int[n + 2, m + 2];
                for(int i=1;i<=n;i++)
                {
                    l = fin.ReadLine();
                    s = l.Split();
                    for (int j = 1; j <= m; j++)
                    {
                        A[i, j] = int.Parse(s[j - 1]);
                        if (A[i, j] == 1) A[i, j] = -1;//interzis
                    }
                }
                //citesc pozitiile
                l = fin.ReadLine();
                s = l.Split();
                i1 = int.Parse(s[0]);
                j1 = int.Parse(s[1]);
                l = fin.ReadLine();
                s = l.Split();
                i2 = int.Parse(s[0]);
                j2 = int.Parse(s[1]);
                //creez butoanele si le pun pe forma
                B = new Button[n + 2, m + 2];
                for(int i=1;i<=n;i++)
                    for(int j=1;j<=m;j++)
                    {
                        B[i, j] = new Button();
                        B[i, j].Text = A[i, j].ToString();
                        if (A[i, j] == 0)
                            B[i, j].BackColor = Color.Green;
                        else
                            B[i, j].BackColor = Color.Red;
                        B[i, j].Width = 40;
                        B[i, j].Height = 40;
                        B[i, j].Top = (i - 1) * 40;
                        B[i, j].Left = (j - 1) * 40;
                        panel1.Controls.Add(B[i, j]);
                    }
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Q = new Queue<pozitie>();
            pozitie x = new pozitie();
            x.i = i1;
            x.j = j1;
            Q.Enqueue(x);
            A[i1, j1] = 1;
            B[i1, j1].Text = "1";
            B[i1, j1].BackColor = Color.Yellow;
            timer1.Start();
        }

        bool inside(int i, int j)
        {
            return i >= 1 && i <= n && j >= 1 && j <= m;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (Q.Count != 0)
            {
                pozitie x = Q.Peek();
                for (int d = 0; d < 4; d++)
                {
                    int inou = x.i + di[d];
                    int jnou = x.j + dj[d];
                    if (inside(inou, jnou) && A[inou, jnou] == 0)
                    {
                        pozitie y = new pozitie();
                        y.i = inou;
                        y.j = jnou;
                        Q.Enqueue(y);
                        A[inou, jnou] = A[x.i, x.j] + 1;
                        B[inou, jnou].Text = A[inou, jnou].ToString();
                        B[inou, jnou].BackColor = Color.Yellow;
                    }
                }
                Q.Dequeue();
            }
            else
            {
                timer1.Stop();
                MessageBox.Show("Robotelul a ajuns dupa " + (A[i2, j2] - 1) + " pasi"); 
            }
        }
    }
}
